m <- read.table("math.txt", header = TRUE, sep = "\t")

head(m)

hist(m$grades)

fit <- lm(m$grades ~ 
  m$school + m$gender + m$Pstatus + factor(m$Medu) + factor(m$Fedu)
  + factor(m$traveltime) + factor(m$studytime) + m$paid + m$higher 
  + m$internet + m$romantic + m$famrel + m$freetime + m$Dalc 
  + m$Walc + m$health + m$absences)
summary(fit)






plot(factor(m$traveltime), m$grades)



# removing outliers

plot(factor(m$Medu), m$grades)
plot(factor(m$Fedu), m$grades)
which(m$Medu == 0)
which(m$Fedu == 0)

plot(m$absence, m$grades)

m <- m[-c(which(m$Medu == 0), which(m$Fedu == 0)), ]
m <- m[which(m$absence < 40), ]

fit <- lm(m$grades ~ 
  m$school + m$gender + m$Pstatus + factor(m$Medu) + factor(m$Fedu)
  + factor(m$traveltime) + factor(m$studytime) + m$paid + m$higher 
  + m$internet + m$romantic + m$famrel + m$freetime + m$Dalc 
  + m$Walc + m$health + m$absences)
summary(fit)











# transforming travel time and study time

plot(factor(m$traveltime), m$grades)
plot(factor(m$studytime), m$grades)

for(i in 1:length(m[,1]))
{
  if(m$traveltime[i] > 1)
    m$traveltime[i] <- 2
}

for(i in 1:length(m[,1]))
{
  if(m$studytime[i] == 1)
    m$studytime[i] <- 1	
  else if(m$studytime[i] == 2)
    m$studytime[i] <- 3.5
  else if(m$studytime[i] == 3)
    m$studytime[i] <- 7.5
  else
    m$studytime[i] <- 12.5
}

fit <- lm(m$grades ~ 
  m$school + m$gender + m$Pstatus + factor(m$Medu) + factor(m$Fedu)
  + factor(m$traveltime) + m$studytime + m$paid + m$higher 
  + m$internet + m$romantic + m$famrel + m$freetime + m$Dalc 
  + m$Walc + m$health + m$absences)
summary(fit)




# taking away insignificant variables

fit <- lm(m$grades ~ 
  m$gender + factor(m$Medu) 
  + factor(m$traveltime) + m$studytime + m$higher 
  + m$romantic + m$famrel + m$freetime + m$Dalc 
  + m$Walc + m$health + m$absences)
summary(fit)

fit <- lm(m$grades ~ 
  m$gender + factor(m$Medu) 
  + factor(m$traveltime) + m$studytime + m$higher 
  + m$romantic + m$absences)
summary(fit)

fit <- lm(m$grades ~ m$gender + factor(m$Medu) 
  + factor(m$traveltime) + m$studytime + m$higher + m$romantic)
summary(fit)

fit <- lm(m$grades ~ m$gender + factor(m$Medu) 
  + m$studytime + m$higher + m$romantic)
summary(fit)








# interaction

plot(m$absence, m$grades)
points(m$absence[which(m$gender == "M")], m$grades[which(m$gender == "M")], col = 4, lwd = 3, pch = 3)
plot(m$absence[which(m$gender == "F")], m$grades[which(m$gender == "F")])

fit <- lm(m$grades ~ m$gender * m$absence + factor(m$Medu) 
  + m$studytime + m$higher + m$romantic)
summary(fit)











hist(residuals(fit))
plot(residuals(fit))
plot(predict(fit), residuals(fit))




































